function pred = pred_gnb(bn, X)
% Get the size information
[n,d] = size(X);

% Compute the probability for each point in each class
prob = zeros(n,2);
for class = [1,2]
    prob(:,class) = ...
        sum(...
        -(X - repmat(bn.mu(class,:), n, 1)).^2 ./ ...
        repmat(2 * bn.sigmaSq(class, :), n, 1)...
        -log(repmat(bn.sigmaSq(class,:), n, 1)), ...
        2) + ...
        log(bn.classP(class));
end

% Safely renormalize
prob = exp(prob - repmat(min(prob, [], 2),1,2));
prob = prob ./ repmat(sum(prob,2), 1, 2 );

pred = prob(:,2);

end

