function [z, xapprox, mse] = projection(X, efaces, xbar, dim)

% Get some dimensions
[n,d] = size(X);

% Compute the projections
z = (X - repmat(xbar, n, 1)) * efaces(1:dim, :)';

% Compute the approximations
xapprox = (z * efaces(1:dim, :)) + repmat(xbar, n, 1);

% Mean Squared error
mse = mean((X(:) - xapprox(:)).^2);

end



